package mahjong.pta.doop;

import java.util.Collection;
import java.util.HashMap;
import java.util.Map;

/**
 * @author Tian Tan
 * @author Yue Li
 */
abstract class DoopItemManager<T> {

	private Map<String, T> name2item = new HashMap<>();
	protected int count = 0;
	
	T get(String name) {
		T item = name2item.get(name);
		if (item == null) {
			item = createItem(name);
			name2item.put(name, item);
		}
		return item;
	}
	
	protected abstract T createItem(String name);

	Collection<T> getAllItems() {
		return name2item.values();
	}
}
