package mahjong.pta.doop;

import mahjong.pta.Obj;
import mahjong.pta.Type;

/**
 * @author Tian Tan
 * @author Yue Li
 */
public class DoopObj extends Obj {

	private final String objName;
	private final Type type;
	private final int id;
	private final String rep;
	
	DoopObj(String objName, Type type, int id) {
		this.objName = objName;
		this.type = type;
		this.id = id;
		this.rep = String.format("%s(%d)", objName, id);
		//this.rep = objName;
	}
	
	@Override
	public int getID() {
		return id;
	}

	@Override
	public String getName() {
		return objName;
	}
	
	@Override
	public Type getType() {
		return type;
	}
	
	@Override
	public String toString() {
		return rep;
	}
}
