package mahjong.pta.doop;

import java.util.HashMap;
import java.util.Map;

import mahjong.pta.Obj;
import mahjong.pta.Type;

/**
 * @author Tian Tan
 * @author Yue Li
 */
class ObjManager extends DoopItemManager<Obj> {

	private final Map<String, String> typeMap;
	private final TypeManager typeManager = new TypeManager();
	
	ObjManager(DataBase db) {
		typeMap = new HashMap<>();
		db.query("OBJ_TYPE").forEach(list -> {
			String objName = list.get(0);
			String typeName = list.get(1);
			typeMap.put(objName, typeName);
		});
	}
	
	@Override
	protected Obj createItem(String name) {
		String typeName = typeMap.get(name);
		return new DoopObj(name, typeManager.get(typeName), ++count);
	}

	
	private class TypeManager extends DoopItemManager<Type> {
		
		@Override
		protected Type createItem(String name) {
			return new DoopType(name, ++count);
		}
	}
}
