package mahjong.pta.doop;

/**
 * @author Tian Tan
 * @author Yue Li
 */
public class Options {
	
	private String dbPath;
	private String cachePath;
	private String app;
	private String outPath;
	private boolean isDebug = false;
	
	public String getDbPath() {
		return dbPath;
	}

	public void setDbPath(String dbPath) {
		this.dbPath = dbPath;
	}

	public String getCachePath() {
		return cachePath;
	}

	public void setCachePath(String cachePath) {
		this.cachePath = cachePath;
	}

	public String getApp() {
		return app;
	}

	public void setApp(String app) {
		this.app = app;
	}

	public String getOutPath() {
		return outPath;
	}

	public void setOutPath(String outPath) {
		this.outPath = outPath;
	}
	
	public boolean isDebug() {
		return this.isDebug;
	}
	
	public void setIsDebug(boolean isDebug) {
		this.isDebug = isDebug;
	}

	public static Options parse(String[] args) {
		Options opt = new Options();
		for (int i = 0; i < args.length; ++i) {
			if (args[i].equals("-db")) {
				i = shift(args, i);
				opt.setDbPath(args[i]);
			} else if (args[i].equals("-cache")) {
				i = shift(args, i);
				opt.setCachePath(args[i]);
			} else if (args[i].equals("-app")) {
				i = shift(args, i);
				opt.setApp(args[i]);
			} else if (args[i].equals("-out")) {
				i = shift(args, i);
				opt.setOutPath(args[i]);
			} else if (args[i].equals("-debug")) {
				opt.setIsDebug(true);
			} else {
				throw new RuntimeException("Unexpected options: " + args[i]);
			}
		}
		return opt;
	}
	
	private static int shift(String[] args, int index) {
		if (args.length == index + 1) {
			System.err.println("error: option " + args[index]
					+ " requires an argument");
			System.exit(1);
		}

		return index + 1;
	}
}
